#include "ca.hpp"
#include <iostream>

using namespace std;

CircularArray queue(10);

#define NTHREADS  3


void *producer(void *arg)
{
        int index = *((int *)arg);
        bool result = false;

        for (int i=0; i<10; i++) {

                cout << "Producer: " << index << " -- Inserting " << i << endl;

                result = queue.insert(i);

                if (result) 
                        cout << "Producer: " << index << " -- Done! " << endl;
                else 
                        cout << "Producer: " << index << " -- Failed! " << endl;
                
                sleep(1);
                
        }
}

void *consumer(void *arg)
{
        int index = *((int *)arg);
        int d;
        bool result;

        for (int i=0; i<10; i++) {

                cout << "Consumer: " << index << " -- extracting " << endl;

                result = queue.extract(d);

                if (result) 
                        cout << "Consumer: " << index << " -- Extracted " 
                             << i << endl;
                else 
                        cout << "Consumer: " << index << " -- Failed " << endl;

                sleep(1);
        }
}

int main()
{
        pthread_t prod[NTHREADS];
        pthread_t cons[NTHREADS];
        int index[10];
        
        for (int i=0; i<NTHREADS; i++) {
                index[i] = i;
                pthread_create(&prod[i], 0, producer, &index[i]);
                pthread_create(&cons[i], 0, consumer, &index[i]);
        }


        for (int i=0; i<NTHREADS; i++) {
                pthread_join(prod[i], 0);
                pthread_join(cons[i], 0);
        }
}



